# Class FileDescriptor

java.lang.Object
java.io.FileDescriptor

public final class FileDescriptor extends Object
Instances of the file descriptor class serve as an opaque handle to the underlying machine-specific structure representing an open file, an open socket, or another source or sink of bytes. The main practical use for a file descriptor is to create a `FileInputStream` or `FileOutputStream` to contain it.

Applications should not create their own file descriptors.

Since:
  1.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final FileDescriptor`
  `err`
  A handle to the standard error stream.
  `static final FileDescriptor`
  `in`
  A handle to the standard input stream.
  `static final FileDescriptor`
  `out`
  A handle to the standard output stream.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FileDescriptor()`
  Constructs an (invalid) FileDescriptor object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `sync()`
  Force all system buffers to synchronize with the underlying device.
  `boolean`
  `valid()`
  Tests if this file descriptor object is valid.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### in

    public static final FileDescriptor in
    A handle to the standard input stream. Usually, this file descriptor is not used directly, but rather via the input stream known as `System.in`.
    See Also:
      - `System.in`

  - ### out

    public static final FileDescriptor out
    A handle to the standard output stream. Usually, this file descriptor is not used directly, but rather via the output stream known as `System.out`.
    See Also:
      - `System.out`

  - ### err

    public static final FileDescriptor err
    A handle to the standard error stream. Usually, this file descriptor is not used directly, but rather via the output stream known as `System.err`.
    See Also:
      - `System.err`

- ## Constructor Details

  - ### FileDescriptor

    public FileDescriptor()
    Constructs an (invalid) FileDescriptor object. The fd or handle is set later.

- ## Method Details

  - ### valid

    public boolean valid()
    Tests if this file descriptor object is valid.
    Returns:
      `true` if the file descriptor object represents a valid, open file, socket, or other active I/O connection; `false` otherwise.

  - ### sync

    public void sync() throws SyncFailedException
    Force all system buffers to synchronize with the underlying device. This method returns after all modified data and attributes of this FileDescriptor have been written to the relevant device(s). In particular, if this FileDescriptor refers to a physical storage medium, such as a file in a file system, sync will not return until all in-memory modified copies of buffers associated with this FileDescriptor have been written to the physical medium. sync is meant to be used by code that requires physical storage (such as a file) to be in a known state For example, a class that provided a simple transaction facility might use sync to ensure that all changes to a file caused by a given transaction were recorded on a storage medium. sync only affects buffers downstream of this FileDescriptor. If any in-memory buffering is being done by the application (for example, by a BufferedOutputStream object), those buffers must be flushed into the FileDescriptor (for example, by invoking OutputStream.flush) before that data will be affected by sync.
    Throws:
      `SyncFailedException` - Thrown when the buffers cannot be flushed, or because the system cannot guarantee that all the buffers have been synchronized with physical media.
    Since:
      1.1